# -*- coding: utf-8 -*-
# Generated by Django 1.11.6 on 2018-05-29 05:52
from __future__ import unicode_literals

from django.db import migrations, models
import django.db.models.deletion


class Migration(migrations.Migration):

    initial = True

    dependencies = [
        ('products', '0001_initial'),
    ]

    operations = [
        migrations.CreateModel(
            name='ProductAttr',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(max_length=128, verbose_name='Name')),
                ('slug', models.CharField(blank=True, db_index=True, max_length=255, verbose_name='Code')),
                ('type', models.PositiveSmallIntegerField(choices=[(1, 'Text'), (2, 'Integer'), (3, 'True / False'), (5, 'Options')], default=1, verbose_name='Type')),
                ('is_required', models.BooleanField(default=False, help_text='You will not be able to update product without filling this field', verbose_name='Required')),
                ('is_visible', models.BooleanField(default=True, help_text='Display this attribute for users', verbose_name='Is visible')),
                ('is_filter', models.BooleanField(default=False, help_text='Display this attribute in products filter', verbose_name='Is filter')),
                ('categories', models.ManyToManyField(blank=True, related_name='attributes', to='products.ProductCategory', verbose_name='Product categories')),
            ],
            options={
                'ordering': ['name'],
                'verbose_name': 'Product attribute',
                'verbose_name_plural': 'Product attributes',
            },
        ),
        migrations.CreateModel(
            name='ProductAttrOption',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(max_length=255, verbose_name='Name')),
                ('attr', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='options', to='attributes.ProductAttr', verbose_name='Attribute')),
            ],
            options={
                'verbose_name': 'Attribute option',
                'verbose_name_plural': 'Attribute options',
            },
        ),
        migrations.CreateModel(
            name='ProductAttrValue',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('value_text', models.TextField(blank=True, null=True, verbose_name='Text')),
                ('value_int', models.IntegerField(blank=True, null=True, verbose_name='Integer')),
                ('value_bool', models.NullBooleanField(verbose_name='Boolean')),
                ('attr', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='values', to='attributes.ProductAttr', verbose_name='Attribute')),
                ('product', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='attr_values', to='products.Product', verbose_name='Product')),
                ('value_option', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='attr_values', to='attributes.ProductAttrOption', verbose_name='Option')),
            ],
            options={
                'ordering': ('attr__name',),
                'verbose_name': 'Product attribute value',
                'verbose_name_plural': 'Product attribute values',
            },
        ),
        migrations.AlterUniqueTogether(
            name='productattrvalue',
            unique_together=set([('attr', 'product')]),
        ),
        migrations.AlterUniqueTogether(
            name='productattroption',
            unique_together=set([('attr', 'name')]),
        ),
    ]
